<?xml version="1.0"?>
<ruleset name="CI PHPMD Ruleset"
         xmlns="http://pmd.sf.net/ruleset/1.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://pmd.sf.net/ruleset/1.0.0
                     http://pmd.sf.net/ruleset_xml_schema.xsd"
         xsi:noNamespaceSchemaLocation="
                     http://pmd.sf.net/ruleset_xml_schema.xsd">
    <description>
        Customisations to the default PHPMD ruleset for our CI
    </description>

    <!-- Check for code cleanliness -->
    <rule ref="rulesets/cleancode.xml">
        <!-- Exclude some test, which seem to contradict best practice or be mis-read?! -->
        <exclude name="StaticAccess" />
        <exclude name="BooleanArgumentFlag" />
        <exclude name="ElseExpression" />
        <!-- Exclude UndefinedVariable until it is fully compatible with static properties -->
        <exclude name="UndefinedVariable" />
    </rule>

    <!-- Check for code size -->
    <rule ref="rulesets/codesize.xml">
        <!-- Exclude some tests, until we understand the effect of them further -->
        <exclude name="CyclomaticComplexity" />
        <exclude name="NPathComplexity" />
        <exclude name="TooManyFields" />
        <exclude name="TooManyPublicMethods" />
        <exclude name="ExcessiveClassComplexity" />
        <!-- Exclude fields we'll customise later -->
        <exclude name="TooManyMethods" />
    </rule>
    <!-- Customise the TooManyMethods test to whitelist "load*" methods -->
    <rule ref="rulesets/codesize.xml/TooManyMethods">
        <properties>
            <property name="ignorepattern" value="(^(set|get|is|has|with|load))i" />
        </properties>
    </rule>

    <!-- Check the design patterns -->
    <rule ref="rulesets/design.xml">
        <!-- Exclude some tests that flag an intentional design practice -->
        <exclude name="ExitExpression" />
        <exclude name="CouplingBetweenObjects" />
        <exclude name="NumberOfChildren" />
    </rule>

    <!-- Check naming convensions used -->
    <rule ref="rulesets/naming.xml">
        <!-- Exclude the ShortVariable test, as we use variables like $i -->
        <exclude name="ShortVariable" />
        <!-- Exclude fields we'll customise later -->
        <exclude name="ShortMethodName" />
        <exclude name="ShortClassName" />
    </rule>
    <!-- Customise the ShortMethodName naming option to allow two-character methods (like ::JS) -->
    <rule ref="rulesets/naming.xml/ShortMethodName">
        <properties>
            <property name="minimum" value="2" />
        </properties>
    </rule>
    <!-- Customise the ShortClassName naming option to allow two-character classes (like CV) -->
    <rule ref="rulesets/naming.xml/ShortClassName">
        <properties>
            <property name="minimum" value="2" />
        </properties>
    </rule>

    <!-- Check for unused code -->
    <rule ref="rulesets/unusedcode.xml">
        <!-- Exclude the UnusedFormalParameter test, as we sometimes use a standard argument pattern -->
        <exclude name="UnusedFormalParameter" />
    </rule>
</ruleset>
